package
{
	import flash.geom.Rectangle;
	
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.events.ResizeEvent;
	import starling.extensions.ParticleDesignerPS;
	import starling.textures.Texture;

	/**
	 * StarlingPart
	 * @author yasu
	 */
	public class StarlingPart extends Sprite
	{

		//----------------------------------------------------------
		//
		//   Static Property 
		//
		//----------------------------------------------------------

		[Embed(source = "assets/bg.png")]
		private static var BackgroundImage:Class;

		[Embed(source = "assets/particle.pex", mimeType = "application/octet-stream")]
		private static var ParticleData:Class;

		[Embed(source = "assets/particleTexture.png")]
		private static var ParticleImage:Class;

		//----------------------------------------------------------
		//
		//   Constructor 
		//
		//----------------------------------------------------------

		public function StarlingPart()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedToStageHandler);
		}

		//----------------------------------------------------------
		//
		//   Property 
		//
		//----------------------------------------------------------

		private var bg:Image;
		private var particles:ParticleDesignerPS;

		//----------------------------------------------------------
		//
		//   Function 
		//
		//----------------------------------------------------------

		private function addedToStageHandler(event:Event):void
		{
			// bg
			bg = Image.fromBitmap(new BackgroundImage());
			bg.width = stage.stageWidth;
			bg.height = stage.stageHeight;
			addChild(bg);

			// particles
			particles = new ParticleDesignerPS(
				XML(new ParticleData()),
				Texture.fromBitmap(new ParticleImage()));

			// position
			particles.emitterX = stage.stageWidth / 2 >> 0;
			particles.emitterY = -50 + (stage.stageHeight * 3 / 4 >> 0);

			// start
			particles.start();
			Starling.juggler.add(particles);
			addChild(particles);

			// resize
			stage.addEventListener(ResizeEvent.RESIZE, stage_resizeHandler);
		}

		private function stage_resizeHandler(event:ResizeEvent):void
		{
			// liquid layout
			Starling.current.viewPort = new Rectangle(0, 0, event.width, event.height);
			stage.stageWidth = event.width;
			stage.stageHeight = event.height;

			// bg
			bg.width = event.width;
			bg.height = event.height;

			// particle position
			particles.emitterX = stage.stageWidth / 2 >> 0;
			particles.emitterY = -50 + (stage.stageHeight * 3 / 4 >> 0);
		}
	}

}
